#include <iostream>
#include <iomanip>
#include <string>
using namespace std;

#include "Math.h"
using namespace arda::Vector;

int main (int argc, char * argv[]) 
   {
   string s1, s2;

   // Vector::scale*()
   {
   cout << "===============================================================" << endl <<
	 "Testing Vector::scale*()" << endl;

   Vector2i v2i = { 1, 2 };
   cout << setw(40) << "v2i: " << vectostr2(v2i, s1) << endl;
   scale2(v2i, 2);
   cout << setw(40) << "scale2(v2i, 2): " << vectostr2(v2i, s1) << endl;
   scale2(v2i, 2.4);
   cout << setw(40) << "scale2(vi, 2.4): " << vectostr2(v2i, s1) << endl;
   scale2(scale2(v2i, 2), 3);
   cout << setw(40) << "scale2(scale2(v2i, 2), 3): " << vectostr2(v2i, s1) << endl;


   Vector3f v3f = { 3.0, 4.1, 5.2 };
   cout << setw(40) << "v3f: " << vectostr3(v3f, s1) << endl;
   scale3(v3f, 2.2f);
   cout << setw(40) << "scale3(v3f,  2.2f): " << vectostr3(v3f, s1) << endl;
   scale3(v3f, 2);
   cout << setw(40) << "scale3(v2f, 2): " << vectostr3(v3f, s1) << endl;

   Vector4d v4d = { 6.0L, 7.1L, 8.2L, 9.3L };
   cout << setw(40) << "vd4: " << vectostr4(v4d, s1) << endl;
   scale4(v4d, 2.0);
   cout << setw(40) << "scale4(v4d, 2.0): " << vectostr4(v4d, s1) << endl;
   scale4(v4d, 2);
   cout << setw(40) << "scale4(v4d, 2): " << vectostr4(v4d, s1) << endl;
   }


   // Vector::dot*()
   {
   cout << "===============================================================" << endl <<
	 "Testing Vector::dot*()" << endl;

   Vector2i v2i[2] = { { 1, 2 }, { 3, 4 } };
   cout << setw(40) << "v2i[0]: " << vectostr2(v2i[0], s1) << endl;
   cout << setw(40) << "v2i[1]: " << vectostr2(v2i[1], s1) << endl;
   cout << setw(40) << "dot2(v2i[0], v2i[1]): " << dot2(v2i[0], v2i[1]) << endl;
   
   Vector3f v3f[3] = { { 1.1f, 2.2f, 3.3f }, { 4.4f, 5.5f, 6.6f } };
   cout << setw(40) << "v3f[0]: " << vectostr3(v3f[0], s1) << endl;
   cout << setw(40) << "v3f[1]: " << vectostr3(v3f[1], s1) << endl;
   cout << setw(40) << "dot3(v3f[0], v3f[1]): " << dot3(v3f[0], v3f[1]) << endl;
   
   Vector4d v4d[3] = { { 1.1, 2.2, 3.3, 4.4 }, { 5.5, 6.6, 7.7, 8.8 } };
   cout << setw(40) << "v4d[0]: " << vectostr4(v4d[0], s1) << endl;
   cout << setw(40) << "v4d[1]: " << vectostr4(v4d[1], s1) <<  endl;
   cout << setw(40) << "dot4(v4d[0], v4d[1]): " << dot4(v4d[0], v4d[1]) << endl;
   
   }

   // Vector::length*()
   {
   cout << "===============================================================" << endl <<
	 "Testing Vector::length*()" << endl;

   Vector2i v2i = { 1, 2 };
   cout << setw(40) << "v2i: " << vectostr2(v2i, s1) << endl;
   cout << setw(40) << "length2(v2i): " << length2(v2i) << endl;
   
   Vector3f v3f = { 1.1f, 2.2f, 3.3f };
   cout << setw(40) << "v3f: " << vectostr3(v3f, s1) << endl;
   cout << setw(40) << "length3(v3f): " << length3(v3f) << endl;
   
   Vector4d v4d = { 1.1, 2.2, 3.3, 4.4 };
   cout << setw(40) << "v4d: " << vectostr4(v4d, s1) << endl;
   cout << setw(40) << "length4(v4d): " << length4(v4d) << endl;
   
   }

   // Vector::add*()
   {
   cout << "===============================================================" << endl <<
	 "Testing Vector::add*()" << endl;

   Vector2i v2i[3] = { { 1, 2 }, { 3, 4 } };
   Vector2i v2ires;
   cout << setw(40) << "v2i[0]: " << vectostr2(v2i[0], s1) << endl;
   cout << setw(40) << "v2i[1]: " << vectostr2(v2i[1], s1) << endl;
   add2(v2i[0], v2i[1], v2ires);
   cout << setw(40) << "add2(v2i[0], v2i[1], v2ires): " << vectostr2(v2ires, s1) << endl;
   cout << setw(40) << "length2(add2(v2i[0], v2i[1], v2ires)): " << length2(add2(v2i[0], v2i[1], v2ires)) << endl;

   Vector3f v3f[3] = { { 1.1f, 2.2f, 3.3f }, { 4.4f, 5.5f, 6.6f } };
   Vector3f v3fres;
   cout << setw(40) << "v3f[0]: " << vectostr3(v3f[0], s1) << endl;
   cout << setw(40) << "v3f[1]: " << vectostr3(v3f[1], s1) << endl;
   add3(v3f[0], v3f[1], v3fres);
   cout << setw(40) << "add3(v3f[0], v3f[1], v3fres): " << vectostr3(v3fres, s1) << endl;
   cout << setw(40) << "length3(add3(v3f[0], v3f[1], v3fres)): " << length3(add3(v3f[0], v3f[1], v3fres)) << endl;

   Vector4d v4d[3] = { { 1.1, 2.2, 3.3, 4.4 }, { 5.5, 6.6, 7.7, 8.8 } };
   Vector4d v4dres;
   cout << setw(40) << "v4d[0]: " << vectostr4(v4d[0], s1) << endl;
   cout << setw(40) << "v4d[1]: " << vectostr4(v4d[1], s1) << endl;
   add4(v4d[0], v4d[1], v4dres);
   cout << setw(40) << "add4(v4d[0], v4d[1], v4dres): " << vectostr4(v4dres, s1) << endl;
   cout << setw(40) << "length4(add4(v4d[0], v4d[1], v4dres)): " << length4(add4(v4d[0], v4d[1], v4dres)) << endl;

   }

   // Vector::add*()
   {
   cout << "===============================================================" << endl <<
	 "Testing Vector::normalize*()" << endl;

   Vector2f v2f = { 1.1, 2.2 };
   cout << setw(40) << "v2f: " << vectostr2(v2f, s1) << endl;
   normalize2(v2f);
   cout << setw(40) << "normalize2(v2f): " << vectostr2(v2f, s1) << endl;
   scale2(normalize2(v2f), 2.0);
   cout << setw(40) << "scale(normalize2(v2f), 2.0): " << vectostr2(v2f, s1) << endl;
   
   Vector3f v3f = { 1.1f, 2.2f, 3.3f };
   cout << setw(40) << "v3f: " << vectostr3(v3f, s1) << endl;
   normalize3(v3f);
   cout << setw(40) << "normalize3(v3f): " << vectostr3(v3f, s1) << endl;
   scale3(normalize3(v3f), 2.0);
   cout << setw(40) << "scale(normalize3(v3f), 2.0): " << vectostr3(v3f, s1) << endl;
   
   Vector4d v4d = { 1.1, 2.2, 3.3, 4.4 };
   cout << setw(40) << "v4d: " << vectostr4(v4d, s1) << endl;
   normalize4(v4d);
   cout << setw(40) << "normalize4(v4d): " << vectostr4(v4d, s1) << endl;
   scale4(normalize4(v4d), 2.0);
   cout << setw(40) << "scale4(normalize4(v4d), 2.0): " << vectostr4(v4d, s1) << endl;
   
   }

   }
